/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
v1.0.2
[ ] 
*/

// Modules
#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

const UNIT_SECOND = (1 << 12)

new g_MsgScreenFade, g_fading[33]

public plugin_init()
{
	register_plugin("[ZPNM] Real Death", "1.0.2", "D i 5 7 i n c T")
	
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
	
	g_MsgScreenFade = get_user_msgid("ScreenFade")
}

public client_disconnect(iID)
	remove_task(iID)

public zpnm_user_spawn_post(iID)
	if (g_fading[iID])
	{
		remove_task(iID)
		g_fading[iID] = false
		
		message_begin(MSG_ONE_UNRELIABLE, g_MsgScreenFade, _, iID)
		write_short(UNIT_SECOND) // duration
		write_short(0) // hold time
		write_short(0x0000) // fade type
		write_byte(0) // red
		write_byte(0) // green
		write_byte(0) // blue
		write_byte(0) // alpha
		message_end()
	}

public fwHamKilledPlayer(const iID)
{
	set_pev(iID, pev_iuser1, 0)
	
	message_begin(MSG_ONE_UNRELIABLE, g_MsgScreenFade, _, iID)
	write_short(UNIT_SECOND * 3)
	write_short(UNIT_SECOND * 2)
	write_short(0x0001)
	write_byte (0)
	write_byte (0)
	write_byte (0)
	write_byte (255)
	message_end()
	
	if (zp_get_user_zombie(iID)
	&& !zp_get_user_nemesis(iID)
	&& !zpnm_get_user_assassin(iID))
		client_cmd(iID, "spk agrunt/ag_die5.wav")
	else
		client_cmd(iID, "spk fvox/flatline.wav")
	
	g_fading[iID] = true
	set_task(3.1, "fading_stopped", iID)
}

public fading_stopped(iID)
	g_fading[iID] = false
